#include<string.h>
#include<stdio.h>
#include<io.h>
#include<fcntl.h>
#include<math.h>
#include<conio.h>
#include<stdlib.h>
#include<dos.h>

typedef struct
{
      int  BM;
      long FZ;
      long U1;
      long HZ;
      long U2;
      long PX;
      long PY;
      int  U3;
      int  BP;
      long U4;
      long AP;
      char UP[16];
      char PL[1024];
}     BMPH;

unsigned char NAMEFIL[80],NAMEDIB[80],NAMERLE[80],HEDFIL[1078];
unsigned char BUF0[2050],BUF1[2050],BUF2[2050],BUF3[2050];
unsigned char BUFERDIB[2048],BUFERRLE[2048];
unsigned int TMP,PAGEGOR,PAGEVER,N,SHAG,A1,A2,A3,A4,A5,A6,A7,A8,A9,A0,I;
int RT1,RT2,RT3,CENTR,KOEF;
long J;
BMPH HEDFI;

main(int argc, char *argv[])
{
 if(argc!=3)
 {
    printf("\n `BMPAREA`, version 3, 06/02/05, 03:00:00, size 47727");
    printf("\n (E.H.Hauser, Baku, `https://ercihware.com`).");
    printf("\n Delimitation of the areas (=>`*.rle`)");
    printf("\n and smoothing of the images (=>`*.dib`).");
    printf("\n Usage: >bmparea.exe mode filename.bmp");
    printf("\n `mode` - mode of the smoothing,");
    printf("\n mode=1,2,...,6 for matrix of weight of pixels:");
    printf("\n111   111   121   121   121   121");
    printf("\n101   111   202   212   222   242");
    printf("\n111   111   121   121   121   121\n");
    exit(0);
 }
     strcpy(NAMEFIL,strupr(argv[2])); TMP=atoi(argv[1]);
     switch (TMP) {
            case 1: CENTR=0; KOEF=1; break;
            case 2: CENTR=1; KOEF=1; break;
            case 3: CENTR=0; KOEF=2; break;
            case 4: CENTR=1; KOEF=2; break;
            case 5: CENTR=2; KOEF=2; break;
            case 6: CENTR=4; KOEF=2; break;
            default: printf("Invalid command line"); exit(1);
     }
     N=strcspn(NAMEFIL,".bmp");
     if (N==NULL) { printf("Invalid command line"); exit(0); };
     strncpy(NAMEDIB,NAMEFIL,N);
     strncpy(NAMERLE,NAMEFIL,N);
     strcat(NAMEDIB,".DIB");
     strcat(NAMERLE,".RLE");
     RT1=open(NAMEFIL,O_RDWR|O_BINARY);
     if(RT1<0)
     {
        printf("Access error!\n"); sleep(2); exit(1);
     }
     J=filelength(RT1); if(J<1079) goto L111;
     read(RT1,&HEDFI,1078);
     PAGEGOR=(unsigned)HEDFI.PX;
     PAGEVER=(unsigned)HEDFI.PY;
     if(HEDFI.HZ!=1078) goto L111;
     if(HEDFI.BP!=8) goto L111;
     RT2=_creat(NAMERLE,0);close(RT2);
     RT2=open(NAMERLE,O_RDWR|O_BINARY);
     RT3=_creat(NAMEDIB,0);close(RT3);
     RT3=open(NAMEDIB,O_RDWR|O_BINARY);
     if (RT2<0 || RT3<0)
     {
        printf("Access error!\n"); sleep(2); exit(1);
     }
     write(RT2,&HEDFI,1078); write(RT3,&HEDFI,1078);
     memset(BUF1,0,2050);memset(BUF2,0,2050);
     lseek(RT1,1078,SEEK_SET);read(RT1,BUF0,PAGEGOR);
     memcpy(&BUF2[1],BUF0,PAGEGOR);
     for(J=1;J<=PAGEVER;J++)
     {
         if (J==PAGEVER) memset(BUF3,0,2050);
         else
         {
            lseek(RT1,1078+PAGEGOR*J,SEEK_SET);
            read(RT1,BUF0,PAGEGOR);memset(BUF3,0,2050);
            memcpy(&BUF3[1],BUF0,PAGEGOR);
         }
         for(I=1;I<=PAGEGOR;I++)
         {
             A1=(unsigned int)BUF1[I-1];
             A2=(unsigned int)BUF1[I];
             A3=(unsigned int)BUF1[I+1];
             A4=(unsigned int)BUF2[I-1];
             A6=(unsigned int)BUF2[I+1];
             A7=(unsigned int)BUF3[I-1];
             A8=(unsigned int)BUF3[I];
             A9=(unsigned int)BUF3[I+1];
             A5=(A7+2*A8+A9)-(A1+2*A2+A3);
             A0=(A3+2*A6+A9)-(A1+2*A4+A7);
             A5=(A5*A5+A0*A0);
             A5=(unsigned int)(sqrt((double)A5/2)/4);
             BUFERRLE[I-1]=(unsigned char)A5;
             A1=0;A2=0;A3=0;A4=0;A5=0;A6=0;A7=0;A8=0;A9=0;SHAG=CENTR;
             A5=(unsigned int)BUF2[I-1]; TMP=SHAG*A5;
             if (J>1) { A2=(unsigned int)BUF1[I-1];SHAG=SHAG+KOEF; }
             if (J<PAGEVER) { A8=(unsigned int)BUF3[I-1];SHAG=SHAG+KOEF; }
             if (I>1)
             {
                A4=(unsigned int)BUF2[I-2];SHAG=SHAG+KOEF;
                if (J>1) { A1=(unsigned int)BUF1[I-2];SHAG=SHAG+1; }
                if (J<PAGEVER) { A7=(unsigned int)BUF3[I-2];SHAG=SHAG+1; }
             }
             if (I<PAGEGOR)
             {
                A6=(unsigned int)BUF2[I];SHAG=SHAG+KOEF;
                if (J>1) { A3=(unsigned int)BUF1[I];SHAG=SHAG+1; }
                if (J<PAGEVER) {A9=(unsigned int)BUF3[I];SHAG=SHAG+1; }
             }
             TMP=A1+A3+A7+A9+KOEF*(A2+A4+A6+A8)+TMP; A0=TMP/SHAG;
             if ((TMP % SHAG)>SHAG/2-1) A0=A0+1;
             BUFERDIB[I-1]=(unsigned char)A0;
         }
         memcpy(BUF1,BUF2,PAGEGOR);
         memcpy(BUF2,BUF3,PAGEGOR);
         write(RT2,BUFERRLE,PAGEGOR);
         write(RT3,BUFERDIB,PAGEGOR);
         N=(int)(J*100/PAGEVER);TMP=wherey();
         gotoxy(1,TMP);printf("%i%s",N,"% ");
     }
     close(RT1);close(RT2);close(RT3);
     exit(0);

L111:  printf("\nFormat/data error in file");exit(1);

}
